#include <stdio.h>

  /* Primjer za razne operatore --- prioriteti, asocijativnost,
     skraceno racunanje logickih izraza. */

  /* Marko naredba PR(x) za ispis cjelobrojne vrijednosti x,
     koja se zadaje kao "tekstualni" parametar makro naredbe PR.
     Kod poziva oblika PR(tekst), zadani tekst izmedju zagrada ( i )
     doslovno se uvrstava (kao tekst) u printf, umjesto izraza "x".
     Svrha = skracenje primjera na 1 slajd.
     Za detalje pogledati zadnje predavanje iz Prog2. */

#define PR(x) printf("%d\n",(x));

int main(void)
{
    int x, y, z;

    x = -4 % 4 / 4 + -4;        PR(x);
      /* Rezultat:
           x = ((-4 % 4) / 4) + (-4)
             = (0 / 4) + (-4)
             = -4;
      */

    y = 4 / -x ++ -4;           PR(x); PR(y);
      /* Rezultat:
         U gornjem izrazu,  operator ++ (postfix oblik) ima najvisi
         prioritet. To znaci da se x povecava za 1 NAKON sto se iskoristi
         trenutna vrijednost od x za racunanje ostatka izraza.
           y = (4 / -(-4)) + (-4)
             = 1 - 4
             = -3;
           x = -3 (zbog povecavanja za 1, nakon koristenja vrijednosti -4);
      */

    y *= z = x + 4 == 4 / -y;   PR(y); PR(z);
      /* Rezultat:
         Zbog asocijativnosti operatora pridruzivanja D->L,
         prvo se racuna z, a onda y.
           z = -3 + 4 == 4 / 3
               Po prioritetu (== je ispod + i /), prvo se racunaju
               -3 + 4 = 1  i  4 / 3 = 1 (cjelobrojno dijeljenje)
             = 1 == 1 (test jednakosti izmedju 1 i 1 je istina)
           z = 1;
           y = y * 1 = -3;
         U ispisu se PRVO pise y, pa onda z. Zato je ispis -3, 1.
      */


      /* Sljedece dvije naredbe ilustriraju SKRACENO racunanje
         logickih izraza. */

    x = x || y && --z;          PR(x); PR(y); PR(z);
      /* Rezultat:
           Prije ove naredbe je x = -3, y = -3, z = 1.

         Izraz x || y && --z se racuna slijeva nadesno, L->D,
         bez obzira na to sto && ima veci prioritet!
         Prema do sada izracunatom, x = -3, prije ove naredbe.
         Ta vrijednost se interpretira kao "istina", pa je
           x = -3 || (y && --z)
             = 1 (istina),
         s tim da se drugi operand za || NE racuna (skraceno racunanje).
         Dakle, izraz y && --z se NE racuna, i z se NE smanjuje!
         Vrijednosti od y i z ostaju kao sto su i bile
           y = -3;
           z = 1;  (a NE 0)
      */

    PR(++x && ++y || ++z) ;     PR(x); PR(y); PR(z);
      /* Rezultat:
           Prije ove naredbe je x = 1, y = -3, z = 1.

         Izraz ++x && ++y || ++z se racuna slijeva nadesno, L->D.
         Zbog ++x, prvo se poveca x za 1, pa je
           x = 2;
         Ta vrijednost se interpretira kao "istina", pa se mora
         izracunati i drugi operand za && (nema skracenja).
         Taj operand je ++y. Prvo poveca y za 1, pa je
           y = -2;
         I ta vrijednost se interpretita kao "istina", pa je
           ++x && ++y = 1
         No, to je prvi operand za ||. Zato sto je on istinit,
         onda je cijeli izraz s ||, takodjer, istinit
           ++x && ++y || ++z = 1
         Medjutim, zbog skracenog racunanja, drugi operand za ||,
         a to je ovdje ++z, se NE racuna.
         Zato vrijednost od z ostaje kao sto je i bila,
           z = 1;  (a ne 2)
         U ispisu se PRVO pise vrijednost izraza, pa x, y, z.
         Zato je ispis 1, 2, -2, 1.
      */


    /* Konacni ispis svih rezultata (napisan u jednom redu):
         -4, -3, -3, -3, 1, 1, -3, 1 (ne 0), 1, 2, -2, 1 (ne 2).
    */

    return 0;
}
